<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Jest Speed Reporter</title>
  <style>
  /* To prevent the table from overflowing container */
  th, td {
    word-wrap: break-word;
    word-break: break-all;
    padding: 0.5rem;
  }

  #myChart {
    max-height: 40rem;
    margin: 2rem;
  }
  </style>
</head>
<body>
<main class="container-fluid">
  <header class="mt-4 d-flex align-items-center">
    <h1>Jest Speed Reporter</h1>
  </header>
  <h2>History</h2>
  <canvas id="myChart"></canvas>
  <details>
    <summary>Table</summary>
    <table>
      <thead>
      <tr>
        <th>Pipeline</th>
        <th>Jobs with junit</th>
        <th>Failed tests</th>
        <th>Failed files</th>
      </tr>
      </thead>
      <tbody>
      {{#history}}
        <tr>
          <td>{{created_at}} / <a href="{{web_url}}">Pipeline {{id}}</a></td>
          <td>{{jestJobsCount}}</td>
          <td>{{failedTestCount}}/{{totalTestCount}}</td>
          <td>{{failedFilesCount}}/{{allFilesCount}}</td>
        </tr>
      {{/history}}
      </tbody>
    </table>
  </details>
  <h2>
    Latest Pipeline
  </h2>
  <p>
    <a href="{{pipeline.web_url}}"> Latest Pipeline at {{pipeline.created_at}} </a>
  </p>
  <ul>
    <li>{{failedTests.length}} failed tests of {{totalTestCount}} total tests</li>
    <li>{{failedFiles.length}} files with test failures ({{allFilesCount}} total files)</li>
  </ul>
  <h3>
    Failed Tests:
  </h3>
  <ul>
    {{#failedTests}}
      <li>
        <details>
          <summary>{{{ name }}} / {{ file }} ({{ time }}s)</summary>

          <pre>{{{failure}}}</pre>
        </details>
      </li>
    {{/failedTests}}
  </ul>
</main>
<script
  src="https://cdn.jsdelivr.net/npm/chart.js@4.4.3/dist/chart.umd.min.js"
  integrity="sha384-JUh163oCRItcbPme8pYnROHQMC6fNKTBWtRG3I3I0erJkzNgL7uxKlNwcrcFKeqF"
  crossorigin="anonymous"

></script>
<script id="chart-data">
  {{&historyJSON}}
</script>
<script type="module">
const ctx = document.getElementById("myChart");

const history = JSON.parse(
  document.getElementById("chart-data").innerText,
).filter((x) => x.created_at > "2024-08-10T00:00:00.000Z");

const min =
  Math.round(
    ((history[0].allFilesCount - history[0].failedFilesCount) * 0.98) / 100,
  ) * 100;

new Chart(ctx, {
  type: "line",
  data: {
    datasets: [
      {
        label: "Failures",
        data: history.map((x) => ({
          y: x.failedFilesCount || null,
          x: x.created_at.substring(0, 10),
        })),
        yAxisID: "y",
        fill: true,
        borderColor: "#f57f6c",
        backgroundColor: "#fdd4cd22",
        spanGaps: true,
      },
      {
        label: "No failures",
        data: history.map((x) => ({
          y: x.allFilesCount ? (x.allFilesCount - x.failedFilesCount) : null,
          x: x.created_at.substring(0, 10),
        })),
        yAxisID: "y1",
        fill: true,
        borderColor: "#63a6e9",
        backgroundColor: "#e9f3fc22",
        spanGaps: true,
      },
    ],
  },
  options: {
    scales: {
      y: {
        type: "linear",
        position: "left",
        title: { text: "Failures", display: true },
        display: "auto",
        suggestedMin: 0,
      },
      y1: {
        id: "B",
        min: min,
        type: "linear",
        position: "right",
        title: { text: "No failures", display: true },
        display: "auto",
        grid: {
          drawOnChartArea: false, // only want the grid lines for one axis to show up
        },
      },
    },
  },
});
</script>
</body>
</html>
